// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/recovery
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/extension -i Manager -t ../../../assets/templates/middleware/recovery -o recovering_middleware.go -l ""

import (
	"context"
	"fmt"

	"git.perx.ru/perxis/perxis-go/pkg/extension"
	"go.uber.org/zap"
)

// recoveringMiddleware implements extension.Manager that is instrumented with logging
type recoveringMiddleware struct {
	logger *zap.Logger
	next   extension.Manager
}

// RecoveringMiddleware instruments an implementation of the extension.Manager with simple logging
func RecoveringMiddleware(logger *zap.Logger) Middleware {
	return func(next extension.Manager) extension.Manager {
		return &recoveringMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *recoveringMiddleware) Action(ctx context.Context, in *extension.ActionRequest) (ap1 *extension.ActionResponse, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Action(ctx, in)
}

func (m *recoveringMiddleware) Check(ctx context.Context, in *extension.CheckRequest) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Check(ctx, in)
}

func (m *recoveringMiddleware) GetDescriptor() (ep1 *extension.ExtensionDescriptor) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
		}
	}()

	return m.next.GetDescriptor()
}

func (m *recoveringMiddleware) Install(ctx context.Context, in *extension.InstallRequest) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Install(ctx, in)
}

func (m *recoveringMiddleware) ListExtensions(ctx context.Context, space string, env string, filter *extension.ListExtensionsFilter) (ipa1 []*extension.Info, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.ListExtensions(ctx, space, env, filter)
}

func (m *recoveringMiddleware) ListRegisteredExtensions(ctx context.Context, extensions ...string) (epa1 []*extension.ExtensionConnector, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.ListRegisteredExtensions(ctx, extensions...)
}

func (m *recoveringMiddleware) RegisterExtensions(ctx context.Context, ext ...*extension.ExtensionConnector) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.RegisterExtensions(ctx, ext...)
}

func (m *recoveringMiddleware) Uninstall(ctx context.Context, in *extension.UninstallRequest) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Uninstall(ctx, in)
}

func (m *recoveringMiddleware) UnregisterExtensions(ctx context.Context, ext ...*extension.ExtensionConnector) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.UnregisterExtensions(ctx, ext...)
}
