package transportgrpc

import (
	grpcerr "git.perx.ru/perxis/perxis-go/pkg/errors/grpc"
	"git.perx.ru/perxis/perxis-go/pkg/locales"
	"git.perx.ru/perxis/perxis-go/pkg/locales/transport"
	pb "git.perx.ru/perxis/perxis-go/proto/locales"
	grpckit "github.com/go-kit/kit/transport/grpc"
)

func NewServer(svc locales.Locales, opts ...grpckit.ServerOption) pb.LocalesServer {
	eps := transport.Endpoints(svc)
	eps = transport.EndpointsSet{
		CreateEndpoint: grpcerr.ServerMiddleware(eps.CreateEndpoint),
		UpdateEndpoint: grpcerr.ServerMiddleware(eps.UpdateEndpoint),
		DeleteEndpoint: grpcerr.ServerMiddleware(eps.DeleteEndpoint),
		ListEndpoint:   grpcerr.ServerMiddleware(eps.ListEndpoint),
	}
	return NewGRPCServer(&eps, opts...)
}
